DROP PROCEDURE IF EXISTS PROCESS_INCLUSIVE_KEY_VALUES
;
CREATE PROCEDURE PROCESS_INCLUSIVE_KEY_VALUES(
	p_art_sys_id BIGINT,
	p_comp_id VARCHAR(255))
BEGIN
	DECLARE member_value VARCHAR(255);
    DECLARE cascade_values BIT;
    DECLARE done BIT;
	DECLARE counter INT;
    
	DECLARE key_values_cursor CURSOR FOR
	SELECT CC.MEMBER_VALUE, CC.CASCADE_VALUES
	FROM CONTENT_CONSTRAINT_V CC
	WHERE CC.ART_ID = p_art_sys_id AND CC.CUBE_INCLUDE = 1 AND CC.MEMBER_ID = p_comp_id AND CC.ACTUAL_DATA = 0;
	
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
    SET done = 0;
    SET counter = 0;
    
	DROP TEMPORARY TABLE IF EXISTS TEMP_CODE_TO_BE_REMOVED_TABLE;
	CREATE TEMPORARY TABLE TEMP_CODE_TO_BE_REMOVED_TABLE (
		CODE_SYS_ID BIGINT
	);
	OPEN key_values_cursor;
    key_values_loop: LOOP
		 FETCH key_values_cursor INTO member_value, cascade_values;
		IF done = 1 THEN 
			LEAVE key_values_loop; 
		END IF;
        
		-- if values to be included have been found, reset the included flag (all values are considered excluded);
		-- use the variable counter to make the update only once (in the first iteration).
		IF (counter = 0) THEN
			UPDATE TEMP_PROCESS_CONSTRAINTS_TABLE SET INCLUDED = 0;
		END IF;
			
		IF cascade_values = 1 THEN
			INSERT INTO TEMP_CODE_TO_BE_REMOVED_TABLE(CODE_SYS_ID) 
			SELECT CDS.CODE_SYS_ID FROM (
				WITH RECURSIVE CHILD_CODES(CODE_SYS_ID, CODE_ID, PARENT_CODE_SYS_ID) AS (
					SELECT CD.CODE_SYS_ID, CD.CODE_ID, CD.PARENT_CODE_SYS_ID
					FROM TEMP_PROCESS_CONSTRAINTS_TABLE CD
					WHERE CD.CODE_ID = member_value AND CD.COMP_ID = p_comp_id
					UNION ALL
					SELECT C.CODE_SYS_ID, C.CODE_ID, C.PARENT_CODE_SYS_ID
					FROM TEMP_PROCESS_CONSTRAINTS_TABLE C
					INNER JOIN CHILD_CODES P ON C.PARENT_CODE_SYS_ID = P.CODE_SYS_ID AND C.COMP_ID = p_comp_id
				) SELECT CODE_SYS_ID FROM CHILD_CODES 
			) CDS;
			
			UPDATE TEMP_PROCESS_CONSTRAINTS_TABLE SET INCLUDED = 1 
			WHERE CODE_SYS_ID IN (SELECT CODE_SYS_ID FROM TEMP_CODE_TO_BE_REMOVED_TABLE) AND COMP_ID = p_comp_id;
		ELSE
			UPDATE TEMP_PROCESS_CONSTRAINTS_TABLE SET INCLUDED = 1 WHERE CODE_ID = member_value AND COMP_ID = p_comp_id;
		END IF;
        
		SET counter = counter + 1;
	END LOOP key_values_loop;
	CLOSE key_values_cursor;
	
	DELETE FROM TEMP_PROCESS_CONSTRAINTS_TABLE WHERE INCLUDED = 0 AND COMP_ID = p_comp_id;
	DROP TEMPORARY TABLE IF EXISTS TEMP_CODE_TO_BE_REMOVED_TABLE;
END
;
